<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body></body>
</html>

<script>
  class Car {
    _make;
    _model;

    constructor(paramMake, paramModel) {
      this._make = paramMake;
      this._model = paramModel;
    }

    drive() {
      console.log(this._make + " driving");
    }
  }

  class ElectricCar extends Car {
    _batteryLevel;

    constructor(paramMake, paramModel, paramBatteryLevel) {
      super(paramMake, paramModel);
      this._batteryLevel = paramBatteryLevel;
    }

    charge() {
      console.log(this._batteryLevel + " charging");
    }
  }

  class PetrolCar extends Car {
    _fuelLevel;

    constructor(paramMake, paramModel, paramFuelLevel) {
      super(paramMake, paramModel);
      this._fuelLevel = paramFuelLevel;
    }

    fillUp() {
      console.log(this._fuelLevel + " filling up");
    }
  }

  var vCar = new Car("Make1", "Model1");
  console.log(vCar);
  vCar.drive();
  console.log(vCar instanceof Car);

  console.log("--------------------------");
  var vECar1 = new ElectricCar("Make2", "Model2", "Battery Level 1");
  console.log(vECar1);
  vECar1.drive();
  vECar1.charge();
  console.log(vECar1 instanceof ElectricCar);
  console.log(vECar1 instanceof Car);

  console.log("--------------------------");
  var vPCar1 = new PetrolCar("Make3", "Model3", "Fuel Level 1");
  console.log(vPCar1);
  vPCar1.drive();
  vPCar1.fillUp();
  console.log(vPCar1 instanceof PetrolCar);
  console.log(vPCar1 instanceof ElectricCar);
  console.log(vPCar1 instanceof Car);
</script>
